// SenderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sender.h"
#include "SenderDlg.h"
#include "Bthutils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSenderDlg dialog


//----  variabile folosite pentru Bluetooth
//SDP record generated by bthnscreate.exe
BYTE rgbSdpRecord[] = {
	0x35, 0x4d, 0x09, 0x00, 0x01, 0x35, 0x11, 0x1c,
	0x29, 0xf9, 0xc0, 0xfd, 0xbb, 0x6e, 0x47, 0x97,
	0x9f, 0xa9, 0x3e, 0xc9, 0xa8, 0x54, 0x29, 0x0c,
	0x09, 0x00, 0x04, 0x35, 0x0c, 0x35, 0x03, 0x19,
	0x01, 0x00, 0x35, 0x05, 0x19, 0x00, 0x03, 0x08,
	0x1a, 0x09, 0x00, 0x06, 0x35, 0x09, 0x09, 0x65,
	0x6e, 0x09, 0x00, 0x6a, 0x09, 0x01, 0x00, 0x09,
	0x00, 0x09, 0x35, 0x08, 0x35, 0x06, 0x19, 0x11,
	0x05, 0x09, 0x01, 0x00, 0x09, 0x01, 0x00, 0x25,
	0x06, 0x53, 0x65, 0x72, 0x69, 0x61, 0x6c
};

//server GUID
WCHAR strGUID[]=L"29F9C0FD-BB6E-4797-9FA9-3EC9A854290C";

//SDP record size constant returned by bthnscreate.exe
#define SDP_RECORD_SIZE 0x0000004f
#define SDP_CHANNEL_OFFSET 40

#define SENDER 1
#define RECEIVER 2

BthUtils objBth;
int g_iMode = SENDER;
int g_iSelectedDeviceIndex;
DeviceInfo *g_pLocalDeviceInfo, *g_pPeerDeviceInfo;

//---- end variabile Bluetooth



CSenderDlg::CSenderDlg(CWnd* pParent /*=NULL*/)
: CDialog(CSenderDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSenderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_DEVICES, ComboBoxDevices);
	DDX_Control(pDX, IDC_BUTTON_SCAN, ButtonScan);
	DDX_Control(pDX, IDC_BUTTON_CONNECT, ButtonConnect);		
}

BEGIN_MESSAGE_MAP(CSenderDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SCAN, &CSenderDlg::OnBnClickedButtonScan)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, &CSenderDlg::OnBnClickedButtonConnect)			
	ON_BN_CLICKED(IDC_BUTTON_UP, &CSenderDlg::OnBnClickedButtonUp)
	ON_BN_CLICKED(IDC_BUTTON_CENTER, &CSenderDlg::OnBnClickedButtonCenter)
	ON_BN_CLICKED(IDC_BUTTON_DOWN, &CSenderDlg::OnBnClickedButtonDown)
	ON_BN_CLICKED(IDC_BUTTON_LEFT, &CSenderDlg::OnBnClickedButtonLeft)
	ON_BN_CLICKED(IDC_BUTTON_RIGHT, &CSenderDlg::OnBnClickedButtonRight)
END_MESSAGE_MAP()


// CSenderDlg message handlers

BOOL CSenderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	// TODO: Add extra initialization here	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSenderDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SENDER_DIALOG_WIDE) : 
		MAKEINTRESOURCE(IDD_SENDER_DIALOG));
	}
}
#endif


void CSenderDlg::OnBnClickedButtonScan()
{
	// scan devicesc and show them in combobox

	int nrDev;

	objBth.DiscoverDevices();
	nrDev = objBth.GetNumDevices();
	DeviceInfo *peerDevices = NULL;

	peerDevices = (DeviceInfo*)malloc(sizeof(DeviceInfo)*nrDev);
	objBth.GetDeviceInfo(peerDevices);

	for(int i=0; i<nrDev; ++i)
	{
		ComboBoxDevices.AddString(peerDevices[i].szDeviceNameAddr);
	}


	//free peerDevices
	if (peerDevices)
		free(peerDevices);

	AfxMessageBox(L"Scan finished!");
}


void DummyFunction(WCHAR* szMessage)
{
	//nu am ce face aici cu mesaju, asta doar trimite
}

void CSenderDlg::OnBnClickedButtonConnect()
{
	int devIndex, result;

	result = objBth.OpenServerConnection(rgbSdpRecord, SDP_RECORD_SIZE, SDP_CHANNEL_OFFSET, DummyFunction);
	
	if (result)
		AfxMessageBox(_T("Connection error!"), MB_OK, 0);
	else
		AfxMessageBox(L"Connected!");
	
	devIndex = ComboBoxDevices.GetCurSel();
	g_iSelectedDeviceIndex = devIndex;
		
}


void SendCommand(WCHAR *szMessage)
{
	int res;

	res = objBth.SendMessageToServer(strGUID, szMessage, g_iSelectedDeviceIndex);
}
void CSenderDlg::OnBnClickedButtonUp()
{
	SendCommand(L"UP");
}

void CSenderDlg::OnBnClickedButtonCenter()
{
	SendCommand(L"CENTER");
}

void CSenderDlg::OnBnClickedButtonDown()
{
	SendCommand(L"DOWN");
}



void CSenderDlg::OnBnClickedButtonLeft()
{
	SendCommand(L"LEFT");
}



void CSenderDlg::OnBnClickedButtonRight()
{
	SendCommand(L"RIGHT");
}
